import { MEMORY_SLOT, TOKEN } from '../../typings/syntaxTypes';
import { FLATTEN_MEMORY_RETURN_OBJECT, GENCODE_AUXVARS, GENCODE_SOLVED_OBJECT } from '../codeGeneratorTypes';
/** Transforms a instruction into const instruction */
export declare function setConstAsmCode(progMemory: MEMORY_SLOT[], code: string, line: number): string;
/** Creates one simple assembly instruction */
export declare function createSimpleInstruction(instruction: string, param1?: string): string;
export declare function toRegister(AuxVars: GENCODE_AUXVARS, InSolved: GENCODE_SOLVED_OBJECT, line: number): GENCODE_SOLVED_OBJECT;
/** Create assembly code for one api function call */
export declare function createAPICallInstruction(AstAuxVars: GENCODE_AUXVARS, ApiToken: TOKEN, RetMem: MEMORY_SLOT, argsMem: MEMORY_SLOT[]): string;
/**
 * From ParamMemObj create an memory object suitable for assembly operations (a regular long variable).
 * Do do rely in createInstruction, all hardwork done internally. Returns also instructions maybe needed for
 * conversion and a boolean to indicate if it is a new object (that must be free later on).
*/
export declare function flattenMemory(AuxVars: GENCODE_AUXVARS, StuffedMemory: MEMORY_SLOT, line: number): FLATTEN_MEMORY_RETURN_OBJECT;
/** Used in function calls. Mem shall be a memory not stuffed */
export declare function forceSetMemFromR0(AuxVars: GENCODE_AUXVARS, Mem: MEMORY_SLOT, line: number): string;
/** Translate one single instruction from ast to assembly code */
export declare function createInstruction(AuxVars: GENCODE_AUXVARS, OperatorToken: TOKEN, MemParam1?: MEMORY_SLOT, MemParam2?: MEMORY_SLOT, rLogic?: boolean, jpFalse?: string, jpTrue?: string): string;
