import { CONTRACT } from './index';
interface CPU_MICROCODE {
    name: string;
    regex: RegExp;
    execute(ContractState: CONTRACT, regexParts: RegExpExecArray): boolean | null;
}
export declare class CPU {
    static readonly cpuMicrocode: CPU_MICROCODE[];
    /** Process one line of assembly code.
      * @returns true or false for no optimization
      * null if line can be optimized (deleted)  */
    static cpu(ContractState: CONTRACT, line: number): boolean | null;
    /**
     * Loop all lines colecting assembly directives
     *
     * @param {CONTRACT} ContractState - Contract to execute function
     * */
    static cpuDeploy(ContractState: CONTRACT): void;
}
export {};
