import { MEMORY_SLOT, TOKEN, TYPE_DEFINITIONS } from '../typings/syntaxTypes';
import { SHAPER_AUXVARS } from './shaperTypes';
/** Process a tokens sequence from a Sentence phrase and return the variables
 * that were defined, in Memory object form
 * @param programTD Side effect: Program.typesDefinitions will receive
 * new arrays definitions, if declared in code.
 * @param AuxVars Read only. It contains information about current function beeing processed.
 * @param phraseCode Code to be analyzed
 * @param structPrefix Optional. If processing struct members, set as struct name + '_'.
 * @returns Array of memory objects declared
 * @throws {Error} on any mistakes
 */
export default function memoryProcessor(programTD: TYPE_DEFINITIONS[], AuxVars: SHAPER_AUXVARS, phraseCode: TOKEN[], structPrefix?: string): MEMORY_SLOT[];
